#include <iostream>
#include <vector>
using namespace std;

int main()
{
    int N,Q,max=0,j;
    cin>>N>>Q;
    vector<char>T;
    for(int i=1;i<=N;i++)
    {
        char c;
        cin>>c;
        T.push_back(c);
    }
    while(Q--)
    {
        int X,Y;
        cin>>X>>Y;
        max=0;
        for(int i=1,j=Y-1;X<Y;X++,i++,j--)
        {
            if(max<j*i)max=i*j;
        }
        cout<<max;
    }
    system("pause");
    return 0;
}